
/**
 * Class describing a human
 * 
 * @author xpopelk
 * @version 2013-12-03
 */
public class Human
{
    private boolean isMan;
    private String forename;
    private String surname;

    /**
     * Constructor for objects of class Student
     * @param forename forename
     * @param surname surname
     * @param isMan true if the human is male, false if it is a woman
     */
    public Human(String forename, String surname, boolean isMan)
    {
        this.forename = forename;
        this.surname = surname;
        this.isMan = isMan;
        
    }
    
    @Override
    public String toString(){
        return forename+" "+surname+" ("+(isMan?"":"fe")+"male)";
    }

    /**
     * Two humans are equal when they have the same name, surname and sex
     * @param other other human
     * @return true if humans are equal, false otherwise
     */
    @Override
    public boolean equals(Object other)
    {
        if (this == other)
           return true;
        if (!(other instanceof Human))
           return false;
        Human human = (Human)other;
        for (int i=0; i<1000;i++){ // delay
        }
        return human.forename.equals(forename) &
               human.surname.equals(surname) &
               human.isMan == isMan;
    }

    /* this hashCode is ok   */
    @Override
    public int hashCode(){
        int h = forename.hashCode()+surname.hashCode();
        return isMan?h:-h;
    }
    
    /* this hashCode is ok 
    @Override
    public int hashCode(){
        return forename.hashCode()+surname.hashCode();
    }*/

    /* bad hashCode() 
    @Override
    public int hashCode(){
        return forename.hashCode();
    }    */
    
    /* very bad hashCode  
    @Override
    public int hashCode(){
        return 0;
    }*/

}
